Bug 1351168 (CVE-2016-5768) - CVE-2016-5768 php: Double free in _php_mb_regex_ereg_replace_exec
Summary: CVE-2016-5768 php: Double free in _php_mb_regex_ereg_replace_exec
Status: CLOSED ERRATA
Alias: CVE-2016-5768
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=low,public=20160623,reported=2...
Keywords: Security
Depends On: 1351180 1356812
Blocks: 1323912 1351183
TreeView+ depends on / blocked
 
Reported: 2016-06-29 11:49 UTC by Andrej Nemec
Modified: 2019-06-11 11:13 UTC (History)
12 users (show)

(edit)
A double free flaw was found in the mb_ereg_replace_callback() function of php which is used to perform regex search. This flaw could possibly cause a PHP application to crash.
Clone Of:
(edit)
Last Closed: 2019-06-08 02:56:04 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2016:2598 normal SHIPPED_LIVE Moderate: php security and bug fix update 2016-11-03 12:12:00 UTC
Red Hat Product Errata RHSA-2016:2750 normal SHIPPED_LIVE Moderate: rh-php56 security, bug fix, and enhancement update 2016-11-15 16:40:02 UTC

Description Andrej Nemec 2016-06-29 11:49:33 UTC
The _php_mb_regex_ereg_replace_exec when called by mb_ereg_replace_callback frees the description twice in case when callback execution failed (i.e. threw an exception).

Upstream bug:

https://bugs.php.net/bug.php?id=72402

Upstream patch:

http://git.php.net/?p=php-src.git;a=commitdiff;h=5b597a2e5b28e2d5a52fc1be13f425f08f47cb62

CVE assignment:

http://seclists.org/oss-sec/2016/q2/589

Comment 1 Andrej Nemec 2016-06-29 12:05:05 UTC
Created php tracking bugs for this issue:

Affects: fedora-all [bug 1351180]

Comment 2 Fedora Update System 2016-07-02 15:27:23 UTC
php-5.6.23-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 3 Fedora Update System 2016-07-02 19:22:11 UTC
php-5.6.23-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 4 Fedora Update System 2016-07-02 19:27:30 UTC
php-5.6.23-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 5 Huzaifa S. Sidhpurwala 2016-07-14 07:39:21 UTC
Analysis:

mb_ereg_replace_callback() is used to perform a regex search, the matched text is them replaced by output of the callback function. Script authors need to provide the callback function as the input to the function. In case the callback execution fails, (Most likely when the script author did not provide a proper callback), then a double-free takes places, causing php application crash.

Comment 7 errata-xmlrpc 2016-11-03 21:05:27 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2016:2598 https://rhn.redhat.com/errata/RHSA-2016-2598.html

Comment 9 errata-xmlrpc 2016-11-15 11:41:37 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 6.7 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.2 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.3 EUS

Via RHSA-2016:2750 https://rhn.redhat.com/errata/RHSA-2016-2750.html


Note You need to log in before you can comment on or make changes to this bug.